/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function drawSliderByVal(slider) {
    var knob=slider.getElementsByTagName('img')[0];
    var p=(slider.val-slider.min)/(slider.max-slider.min);
    var x=(slider.scrollWidth-30)*p;
    knob.style.left=x+"px";
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function setSliderByClientX(slider, clientX) {
    var p=(clientX-slider.offsetLeft-15)/(slider.scrollWidth-30);
    slider.val=(slider.max-slider.min)*p + slider.min;
    if (slider.val>slider.max) slider.val=slider.max;
    if (slider.val<slider.min) slider.val=slider.min;

    drawSliderByVal(slider);
    slider.onchange(slider.val, slider.num);
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function sliderClick(e) {
    if (!e && window.event) e=window.event;
    if (!e) return;
    var el;
    if (e.target) el=e.target;
    if (e.srcElement) el=e.srcElement;
    if (!el.id.match(/slider\d+/)) return;

    setSliderByClientX(el, e.clientX);
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function sliderMouseMove(e) {
    if (!e && window.event) e=window.event;
    if (!e) return;
    var el;
    if (e.target) el=e.target;
    if (e.srcElement) el=e.srcElement;
    el=el.parentNode;
    if (!el.id) return;
    if (!el.id.match(/slider\d+/)) return;

    if (activeSlider<0) return;
    setSliderByClientX(el, e.clientX);
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
function attachSliderEvents() {
    var divs=document.getElementsByTagName('div');
    var divNum;
    for(var i=0; i<divs.length; i++) {
        if (divNum=divs[i].id.match(/\bslider(\d+)\b/)) {
            divNum=parseInt(divNum[1]);
            divs[i].min=slider[divNum].min;
            divs[i].max=slider[divNum].max;
            divs[i].val=slider[divNum].val;
            divs[i].onchange=slider[divNum].onchange;
            divs[i].num=divNum;
            divs[i].onclick=sliderClick;
            var knob=divs[i].getElementsByTagName('img')[0];
            knob.onmousedown=(function(){activeSlider=this.parentNode.num;});
            knob.onmouseup=(function(){activeSlider=-1;});
            knob.onmouseout=(function(){return false;});
        }
    }
}
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
addAnEvent(window, 'load', attachSliderEvents);
addAnEvent(document, 'mousemove', sliderMouseMove);
var activeSlider=-1;
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
